// Code generated by go-swagger; DO NOT EDIT.

package account

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/openziti/zrok/rest_model_zrok"
)

// NewInviteParams creates a new InviteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewInviteParams() *InviteParams {
	return &InviteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewInviteParamsWithTimeout creates a new InviteParams object
// with the ability to set a timeout on a request.
func NewInviteParamsWithTimeout(timeout time.Duration) *InviteParams {
	return &InviteParams{
		timeout: timeout,
	}
}

// NewInviteParamsWithContext creates a new InviteParams object
// with the ability to set a context for a request.
func NewInviteParamsWithContext(ctx context.Context) *InviteParams {
	return &InviteParams{
		Context: ctx,
	}
}

// NewInviteParamsWithHTTPClient creates a new InviteParams object
// with the ability to set a custom HTTPClient for a request.
func NewInviteParamsWithHTTPClient(client *http.Client) *InviteParams {
	return &InviteParams{
		HTTPClient: client,
	}
}

/*
InviteParams contains all the parameters to send to the API endpoint

	for the invite operation.

	Typically these are written to a http.Request.
*/
type InviteParams struct {

	// Body.
	Body *rest_model_zrok.InviteRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the invite params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *InviteParams) WithDefaults() *InviteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the invite params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *InviteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the invite params
func (o *InviteParams) WithTimeout(timeout time.Duration) *InviteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the invite params
func (o *InviteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the invite params
func (o *InviteParams) WithContext(ctx context.Context) *InviteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the invite params
func (o *InviteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the invite params
func (o *InviteParams) WithHTTPClient(client *http.Client) *InviteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the invite params
func (o *InviteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the invite params
func (o *InviteParams) WithBody(body *rest_model_zrok.InviteRequest) *InviteParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the invite params
func (o *InviteParams) SetBody(body *rest_model_zrok.InviteRequest) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *InviteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
