// Code generated by go-swagger; DO NOT EDIT.

package share

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/openziti/zrok/rest_model_zrok"
)

// NewAccessParams creates a new AccessParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAccessParams() *AccessParams {
	return &AccessParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAccessParamsWithTimeout creates a new AccessParams object
// with the ability to set a timeout on a request.
func NewAccessParamsWithTimeout(timeout time.Duration) *AccessParams {
	return &AccessParams{
		timeout: timeout,
	}
}

// NewAccessParamsWithContext creates a new AccessParams object
// with the ability to set a context for a request.
func NewAccessParamsWithContext(ctx context.Context) *AccessParams {
	return &AccessParams{
		Context: ctx,
	}
}

// NewAccessParamsWithHTTPClient creates a new AccessParams object
// with the ability to set a custom HTTPClient for a request.
func NewAccessParamsWithHTTPClient(client *http.Client) *AccessParams {
	return &AccessParams{
		HTTPClient: client,
	}
}

/*
AccessParams contains all the parameters to send to the API endpoint

	for the access operation.

	Typically these are written to a http.Request.
*/
type AccessParams struct {

	// Body.
	Body *rest_model_zrok.AccessRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the access params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AccessParams) WithDefaults() *AccessParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the access params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AccessParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the access params
func (o *AccessParams) WithTimeout(timeout time.Duration) *AccessParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the access params
func (o *AccessParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the access params
func (o *AccessParams) WithContext(ctx context.Context) *AccessParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the access params
func (o *AccessParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the access params
func (o *AccessParams) WithHTTPClient(client *http.Client) *AccessParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the access params
func (o *AccessParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the access params
func (o *AccessParams) WithBody(body *rest_model_zrok.AccessRequest) *AccessParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the access params
func (o *AccessParams) SetBody(body *rest_model_zrok.AccessRequest) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *AccessParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
