// Code generated by go-swagger; DO NOT EDIT.

package admin

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"context"
	"net/http"

	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/openziti/zrok/rest_model_zrok"
)

// GrantsHandlerFunc turns a function with the right signature into a grants handler
type GrantsHandlerFunc func(GrantsParams, *rest_model_zrok.Principal) middleware.Responder

// Handle executing the request and returning a response
func (fn GrantsHandlerFunc) Handle(params GrantsParams, principal *rest_model_zrok.Principal) middleware.Responder {
	return fn(params, principal)
}

// GrantsHandler interface for that can handle valid grants params
type GrantsHandler interface {
	Handle(GrantsParams, *rest_model_zrok.Principal) middleware.Responder
}

// NewGrants creates a new http.Handler for the grants operation
func NewGrants(ctx *middleware.Context, handler GrantsHandler) *Grants {
	return &Grants{Context: ctx, Handler: handler}
}

/*
	Grants swagger:route POST /grants admin grants

Grants grants API
*/
type Grants struct {
	Context *middleware.Context
	Handler GrantsHandler
}

func (o *Grants) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewGrantsParams()
	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		*r = *aCtx
	}
	var principal *rest_model_zrok.Principal
	if uprinc != nil {
		principal = uprinc.(*rest_model_zrok.Principal) // this is really a rest_model_zrok.Principal, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}

// GrantsBody grants body
//
// swagger:model GrantsBody
type GrantsBody struct {

	// email
	Email string `json:"email,omitempty"`
}

// Validate validates this grants body
func (o *GrantsBody) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this grants body based on context it is used
func (o *GrantsBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *GrantsBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GrantsBody) UnmarshalBinary(b []byte) error {
	var res GrantsBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
